/*
 * Revision Control Information
 *
 * /projects/hsis/CVS/utilities/bdd_bf/bdd_bf.h,v
 * shiple
 * 1.1.1.1
 * 1993/08/02 17:33:33
 *
 */

/* 
 * Boolean formulas connectives.  Used to build a Boolean expression.
 */
typedef enum {
    BDD_FML_AND,
    BDD_FML_NOT,
    BDD_FML_OR,
    BDD_FML_XOR,
    BDD_FML_OPRND,
    BDD_FML_COF
} bdd_fml_type_t;

/*
 * Methods for building Boolean formulas.
 */
typedef enum {
    BDD_BUILD_BINARY,          /* build using only binary BDD operators */
    BDD_BUILD_MULTI            /* build in one pass through BDDs */
} bdd_build_type_t;

/*
 * Exported functions.
 */
EXTERN bdd_t *bdd_build_formula ARGS((array_t *, array_t *, bdd_build_type_t));
EXTERN bdd_t *bdd_and_multi ARGS((array_t *, bdd_build_type_t));
EXTERN bdd_t *bdd_or_multi ARGS((array_t *, bdd_build_type_t));
EXTERN void bdd_bf_initialize_manager ARGS((bdd_manager *));
EXTERN void bdd_bf_uninitialize_manager ARGS((bdd_manager *));
EXTERN void bdd_bf_print_stats ARGS((bdd_manager *, FILE *));

