#include "mdd.h"

/*
 * MDD Package
 * /projects/hsis/CVS/utilities/mdd/mdd_geq_s.c,v
 *
 * Author: Timothy Kam
 * 1993/08/03 22:38:36
 * 1.2
 *
 * Copyright 1992 by the Regents of the University of California.
 *
 * All rights reserved.  Permission to use, copy, modify and distribute
 * this software is hereby granted, provided that the above copyright
 * notice and this permission notice appear in all copies.  This software
 * is made available as is, with no warranties.
 */

mdd_t *
mdd_geq_s(mgr, mvar1, mvar2)
mdd_manager *mgr;
int mvar1, mvar2;
{
/*    mvar_type x, y;
    bvar_type bx, by;
    mdd_t *t, *tt, *ttb;
    int i;
    array_t *mvar_list;
    array_t *bvar_list;
    bdd_external_hooks *hook;
    mdd_t *one, *zero;
    mdd_t *x_is_dont_care_or_max_val,
	  *y_is_dont_care_or_max_val,
	  *both_are_dont_cares_or_max_val;
    int virtual_range;


    hook =  bdd_get_external_hooks(mgr);
    mvar_list = ((mdd_hook_type *)(hook->mdd))->mvar_list;                                                                                
    bvar_list = ((mdd_hook_type *)(hook->mdd))->bvar_list;                                                                                

    one = mdd_one(mgr);
    zero = mdd_zero(mgr);

    x = array_fetch(mvar_type, mvar_list, mvar1);
    y = array_fetch(mvar_type, mvar_list, mvar2);
    if (x.values != y.values) 
	fail("mdd_fast_lt: 2 mvars have incompatible value ranges\n");

    t = mdd_one(mgr);
    for (i=(x.encode_length-1); i>=0; i--) {
	bx = array_fetch(bvar_type, bvar_list, x.start_vertex + i*x.stride);
	by = array_fetch(bvar_type, bvar_list, y.start_vertex + i*y.stride);
	ttb = mdd_ite(by.node, zero, t, 1, 1, 1);
	tt  = mdd_ite(by.node, t, one, 1, 1, 1);
	mdd_free(t);
	t = mdd_ite(bx.node, tt, ttb, 1, 1, 1);
        mdd_free(tt);
	mdd_free(ttb);
    }

    virtual_range = (int) ( pow(2.0, (double)x.encode_length));
    if (x.values < virtual_range) {
	x_is_dont_care_or_max_val = build_geq_c(mgr, mvar1, x.values - 1);
	y_is_dont_care_or_max_val = build_geq_c(mgr, mvar2, y.values - 1);
	
	both_are_dont_cares_or_max_val = mdd_and(x_is_dont_care_or_max_val, y_is_dont_care_or_max_val, 1, 1);

	t = bdd_or( t, both_are_dont_cares_or_max_val, 1, 1);
	
	}

    mdd_free(one);
    mdd_free(zero);

    return t;
*/
    return mdd_geq(mgr, mvar1, mvar2);
}
